/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2010 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 *		kernel.h̃vZbTˑiRX630pj
 *
 *  ̃CN[ht@ĆCtarget_kernel.hi܂́CCN
 *  [ht@Cĵ݂CN[hD̃t@C
 *  ڃCN[hĂ͂ȂȂD
 */

#ifndef TOPPERS_PRC_KERNEL_H
#define TOPPERS_PRC_KERNEL_H

/*
 *  J[l{̂RpC邽߂̃}N`
 *
 *  {ł1֐1IuWFNgt@CɃRpC邱ƂłȂ߁C
 *  ALLFUNC}N`D
 */
#define ALLFUNC


/*
 *  T|[g@\̒`
 */
#define TOPPERS_TARGET_SUPPORT_DIS_INT		/* dis_intT|[g */
#define TOPPERS_TARGET_SUPPORT_ENA_INT		/* ena_intT|[g */


/*
 *  J[lǗ̊ݗDx͈̔
 *
 *  TMIN_INTPRI̒`ύX邱ƂŁCǂ̃xݗDx
 *  ̂J[lǗO݂̊Ƃ邩ύXłD
 *
 *  TMIN_INTPRIɐݒłĺC-15`-1͈̔͂łDႦTMIN_INTPRI
 *  -14ɐݒ肷ƁCNMIɉăx7݂̊J[lǗOƂȂD
 *  TMIN_INTPRI-15ɐݒ肷ƁCNMIȊOɃJ[lǗO݂̊
 *  ݂ȂƂɂȂD
 */
#ifndef TMIN_INTPRI
#define TMIN_INTPRI		( -15 )		/* ݗDx̍ŏliōlj*/
#endif /* TMIN_INTPRI */
#define TMAX_INTPRI		( -1 )		/* ݗDx̍őliŒlj */


/*
 *  ݑ̒`
 */
#define	TA_POSEDGE		TA_EDGE			/* |WeBuGbWgK */
#define	TA_NEGEDGE		UINT_C( 0x04 )	/* lKeBuGbWgK */
#define	TA_BOTHEDGE		UINT_C( 0x08 )	/* GbWgK */

#define	TA_LOWLEVEL		UINT_C( 0x10 )	/* Lx */


/*
 *  ftHg̊/Onh̗L
 */
/*#define	OMIT_DEFAULT_INT_HANDLER*/
/*#define	OMIT_DEFAULT_EXC_HANDLER*/


#endif /* TOPPERS_PRC_KERNEL_H */
