/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2014-2016 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: echonet_dbg.h 164 2016-03-07 11:33:50Z coas-nagasima $
 */

/*
 *		ECHONET Lite ^XN fobOo
 */

#ifndef TOPPERS_ECHONET_DBG_H
#define TOPPERS_ECHONET_DBG_H

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SEM_ECN_DBG_UDP_SYSLOG
 #include "echonet_dbg_udp.h"
#endif

/*#include ".h"*/
#include "echonet.h"
#include "echonet_fbs.h"

/* ECN_SRC_LOC: \[X̃t@Cƍsԍ}N */
#ifndef ECN_SRC_LOC
 #ifndef _ECN_BLD_BASE_DIR
  #define __ECN_SRC_LOC(fnam, line) fnam "(" #line ")"
 #else
  #define ___ECN_SRC_LOC(fnam, line) fnam "(" #line ")"
  #define __ECN_SRC_LOC(fnam, line) \
	( \
		sizeof(_ECN_BLD_BASE_DIR) < sizeof(___ECN_SRC_LOC(fnam, line)) ? \
		(	&(___ECN_SRC_LOC(fnam, line))[sizeof(_ECN_BLD_BASE_DIR) - 1] \
		) \
		:	___ECN_SRC_LOC(fnam, line) \
	)
 #endif
 #define _ECN_SRC_LOC(fnam, line) __ECN_SRC_LOC(fnam, line)
 #define ECN_SRC_LOC _ECN_SRC_LOC(__FILE__, __LINE__)
#endif

#ifdef ECN_DBG_PUT_ENA
#define ECN_DBG_PUT(...) _ecn_dbg_dbgput(ECN_SRC_LOC, __VA_ARGS__)
#else
#define ECN_DBG_PUT(...)
#endif

/* fobOo(CARP) */
#ifdef ECN_CAP_PUT_ENA
#define ECN_CAP_PUT(...) _ecn_dbg_dbgput(ECN_SRC_LOC, __VA_ARGS__)
#else
#define ECN_CAP_PUT(...)
#endif

/*
 * fobOo
 * F		ECN_DBG_PUT( "task start" );
 */
int _ecn_dbg_dbgput(const char *, const char *, ...);

/*
 * oCi_vo
 */
void _ecn_dbg_bindmp(const T_ECN_FST_BLK *buffer, size_t len);

/*
 * ECHONET LiteT[rXR[hϊ
 */
const char *_ecn_dbg_esv2str(uint8_t fa_esv);

/*
 * ECN_ENOD_ID̕ϊ
 */
const char *_ecn_dbg_enod2str(ECN_ENOD_ID fa_enod_id);

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_ECHONET_DBG_H */
